var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import InputMask from 'react-input-mask';
import TextField from '@material-ui/core/TextField';

function MaskWidget(props) {
    var value = props.value,
        readonly = props.readonly,
        disabled = props.disabled,
        autofocus = props.autofocus,
        onBlur = props.onBlur,
        onFocus = props.onFocus,
        options = props.options,
        schema = props.schema,
        metadata = props.schema.metadata,
        formContext = props.formContext,
        registry = props.registry,
        inputProps = _objectWithoutProperties(props, ['value', 'readonly', 'disabled', 'autofocus', 'onBlur', 'onFocus', 'options', 'schema', 'schema', 'formContext', 'registry']);

    var onChange = function onChange(_ref) {
        var value = _ref.target.value;

        return props.onChange(value ? value : options.emptyValue);
    };

    return React.createElement(
        InputMask,
        _extends({}, inputProps, {
            readOnly: metadata.readonly,
            disabled: metadata.readonly,
            autoFocus: autofocus,
            required: metadata.required,
            value: value || '',
            onChange: onChange,
            mask: schema.mask,
            formatChars: { '9': '[0-9]', 'a': '[A-Za-z]', 'A': '[A-Z]', '*': '[A-Za-z0-9]' },
            onBlur: onBlur && function (event) {
                return onBlur(inputProps.id, event.target.value);
            },
            onFocus: onFocus && function (event) {
                return onFocus(inputProps.id, event.target.value);
            }
        }),
        function (inputProps) {
            return React.createElement(TextField, _extends({}, inputProps, { type: 'text', margin: 'none', fullWidth: true }));
        }
    );
}

MaskWidget.defaultProps = {
    required: false,
    disabled: false,
    readonly: false,
    autofocus: false
};

MaskWidget.propTypes = process.env.NODE_ENV !== "production" ? {
    id: PropTypes.string.isRequired,
    placeholder: PropTypes.string,
    value: PropTypes.any,
    required: PropTypes.bool,
    disabled: PropTypes.bool,
    readonly: PropTypes.bool,
    autofocus: PropTypes.bool,
    onChange: PropTypes.func,
    onBlur: PropTypes.func,
    onFocus: PropTypes.func
} : {};

export default MaskWidget;