'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _AddCircleOutline = require('@material-ui/icons/AddCircleOutline');

var _AddCircleOutline2 = _interopRequireDefault(_AddCircleOutline);

var _CheckCircle = require('@material-ui/icons/CheckCircle');

var _CheckCircle2 = _interopRequireDefault(_CheckCircle);

var _ResponsiveDialog = require('../ResponsiveDialog/ResponsiveDialog');

var _ResponsiveDialog2 = _interopRequireDefault(_ResponsiveDialog);

var _FileGrid = require('./FileGrid');

var _FileGrid2 = _interopRequireDefault(_FileGrid);

var _FileGridItem = require('./FileGridItem');

var _FileGridItem2 = _interopRequireDefault(_FileGridItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PhotoGalleryModal = function (_Component) {
    _inherits(PhotoGalleryModal, _Component);

    function PhotoGalleryModal() {
        var _temp, _this, _ret;

        _classCallCheck(this, PhotoGalleryModal);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
            newSelection: [].concat(_this.props.selecteds)
        }, _this.handleSelectPhotos = function () {
            var newSelection = _this.state.newSelection;
            var onConfirm = _this.props.onConfirm;


            onConfirm(newSelection);
            _this.setState({ newSelection: [] });
        }, _this.createHandleFileChange = function (type, file) {
            return function () {
                _this.setState(function (state) {
                    var newSelection = type === 'ADD' ? [].concat(state.newSelection, [file]) : type === 'REMOVE' ? state.newSelection.filter(function (image) {
                        return image.id !== file.id;
                    }) : state.newSelection;

                    return { newSelection: newSelection };
                });
            };
        }, _this.renderFileItem = function (file, index) {
            var fileGridProps = {
                onActionClick: _this.createHandleFileChange('ADD', file),
                actionIcon: _react2.default.createElement(_AddCircleOutline2.default, { style: { color: '#fff' } })
            };

            if (file.selected) {
                fileGridProps = {
                    onActionClick: _this.createHandleFileChange('REMOVE', file),
                    actionIcon: _react2.default.createElement(_CheckCircle2.default, { style: { color: '#fff' } })
                };
            }

            return _react2.default.createElement(_FileGridItem2.default, _extends({
                key: index,
                index: index,
                file: file
            }, fileGridProps));
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    PhotoGalleryModal.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        var selecteds = nextProps.selecteds;
        var newSelection = this.state.newSelection;

        var hasChangeSelecteds = JSON.stringify(selecteds) === JSON.stringify(newSelection);

        hasChangeSelecteds && this.setState({ newSelection: [].concat(selecteds) });
    };

    PhotoGalleryModal.prototype.getGalleryWithSelectedImages = function getGalleryWithSelectedImages() {
        var newSelection = this.state.newSelection;
        var gallery = this.props.gallery;

        var selectedIds = newSelection.map(function (file) {
            return file.id;
        });

        return gallery.map(function (image) {
            return _extends({}, image, { selected: selectedIds.includes(image.id) });
        });
    };

    PhotoGalleryModal.prototype.render = function render() {
        var _props = this.props,
            open = _props.open,
            gallery = _props.gallery,
            title = _props.title,
            onCancel = _props.onCancel;


        var galleryWithSelecteds = this.getGalleryWithSelectedImages();

        return _react2.default.createElement(
            _ResponsiveDialog2.default,
            {
                open: open,
                title: title,
                cancelText: 'Cancelar',
                okText: 'Confirmar',
                onCancel: onCancel,
                onOk: this.handleSelectPhotos
            },
            gallery.length ? _react2.default.createElement(_FileGrid2.default, {
                files: galleryWithSelecteds,
                render: this.renderFileItem
            }) : _react2.default.createElement(
                _Typography2.default,
                { type: 'body2' },
                'A galeria n\xE3o possui nenhuma imagem.'
            )
        );
    };

    return PhotoGalleryModal;
}(_react.Component);

PhotoGalleryModal.defaultProps = {
    title: 'Galeria',
    open: false,
    gallery: [],
    selecteds: []
};

PhotoGalleryModal.propTypes = process.env.NODE_ENV !== "production" ? {
    open: _propTypes2.default.bool.isRequired,
    gallery: _propTypes2.default.array.isRequired,
    selecteds: _propTypes2.default.array.isRequired,
    title: _propTypes2.default.string,
    onCancel: _propTypes2.default.func.isRequired,
    onConfirm: _propTypes2.default.func.isRequired
} : {};

exports.default = PhotoGalleryModal;
module.exports = exports['default'];