'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Dialog = require('@material-ui/core/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _DialogActions = require('@material-ui/core/DialogActions');

var _DialogActions2 = _interopRequireDefault(_DialogActions);

var _DialogContent = require('@material-ui/core/DialogContent');

var _DialogContent2 = _interopRequireDefault(_DialogContent);

var _DialogTitle = require('@material-ui/core/DialogTitle');

var _DialogTitle2 = _interopRequireDefault(_DialogTitle);

var _withMobileDialog = require('@material-ui/core/withMobileDialog');

var _withMobileDialog2 = _interopRequireDefault(_withMobileDialog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ResponsiveDialog(props) {
    var fullScreen = props.fullScreen,
        open = props.open,
        title = props.title,
        okText = props.okText,
        cancelText = props.cancelText,
        onCancel = props.onCancel,
        onOk = props.onOk,
        children = props.children;


    return _react2.default.createElement(
        _Dialog2.default,
        {
            fullScreen: fullScreen,
            open: open,
            onClose: onCancel,
            PaperProps: {
                style: {
                    maxWidth: '620px'
                }
            }
        },
        _react2.default.createElement(
            _DialogTitle2.default,
            null,
            title
        ),
        _react2.default.createElement(
            _DialogContent2.default,
            null,
            children
        ),
        _react2.default.createElement(
            _DialogActions2.default,
            null,
            _react2.default.createElement(
                _Button2.default,
                {
                    onClick: onCancel,
                    color: 'default'
                },
                cancelText
            ),
            _react2.default.createElement(
                _Button2.default,
                {
                    onClick: onOk,
                    color: 'primary'
                },
                okText
            )
        )
    );
}

ResponsiveDialog.defaultProps = {
    okText: 'Ok',
    cancelText: 'Cancel',
    title: '',
    open: false,
    showActions: true
};

ResponsiveDialog.propTypes = process.env.NODE_ENV !== "production" ? {
    showActions: _propTypes2.default.bool,
    open: _propTypes2.default.bool.isRequired,
    title: _propTypes2.default.string.isRequired,
    okText: _propTypes2.default.string,
    cancelText: _propTypes2.default.string,
    onCancel: _propTypes2.default.func,
    onOk: _propTypes2.default.func,
    /* withMobileDialog */
    fullScreen: _propTypes2.default.bool.isRequired
} : {};

exports.default = (0, _withMobileDialog2.default)()(ResponsiveDialog);
module.exports = exports['default'];