'use strict';

exports.__esModule = true;
exports.default = download;

var _fileSaver = require('file-saver');

var _fileSaver2 = _interopRequireDefault(_fileSaver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parseBlob(response) {
    return response.blob();
}

function download(file) {
    var headers = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var name = file.name,
        link = file.link;


    fetch(link, { 'method': 'GET', headers: headers }).then(parseBlob).then(function (blob) {
        return _fileSaver2.default.saveAs(blob, name);
    }).catch(function (e) {
        return console.error(e);
    });
}
module.exports = exports['default'];